#!/usr/bin/python

import sys;
from random import *;
from opencv.cv import *;
from opencv.highgui import *;


def saveImage(img,base):
    # xml
    file=open(base+".xml","w");

    file.write("<data>");
    for y in range(10):
        for x in range(10):
            file.write("<pixel>%d</pixel>"%(int)(img[x][y]>=128));
            print "%d:%d "%(y*10+x,(int)(img[x][y]>=128)),;
            
    file.write("</data>");
    print;
    file.close();
    
    #txt
    # bmp
    cvSaveImage(base+".bmp",img);

if len(sys.argv)<6:
    print "Usage xmlgen <image> <basename> <noise> <amount> <class>.";
    exit(0);

orig=cvLoadImage(sys.argv[1]);
base=sys.argv[2];
noise=float(sys.argv[3]);
amount=int(sys.argv[4]);
cl=sys.argv[5];

img=cvLoadImage(sys.argv[1],0);
img1=cvCloneImage(img);

for n in range(0,amount):
    print cl,;
    for y in range(10):
        for x in range(10):
            if (noise>random()):
                img1[x][y]=255-img[x][y];
            else:
                img1[x][y]=img[x][y];
                
    saveImage(img1,"%s%d"%(base,n));

